@echo off

echo //
echo // INTERSTELLAR CONSOLE CXg[
echo // Copyright (C) 2025- Misato Observatory, Wakayama, Japan
echo //

REM ExecutionPolicy of powershell.exe
set EXPOLICY=Bypass

REM concatenate directory name with spc
if "%1" == "" (
  echo ERROR: empty arg
  timeout /t 2 /nobreak >nul
  exit 1
) else if "%2" == "" (
  set PD=%1
) else (
  set PD=%1 %2
)

echo PACKAGE:
cd /D "%PD%"
if errorlevel 1 (
  echo ERROR: Network drive is not supported
  powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\unc_err_msg.ps1
  exit 1
)
cd
timeout /t 3 /nobreak >nul
REM pause

set STELDIR=C:\Program Files\Stellarium
if not exist "%STELDIR%" (
  powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\not_installed_msg.ps1
  exit 1
)

set SKYCULDIR=%STELDIR%\skycultures
if not exist "%SKYCULDIR%" (
  powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\not_installed_msg.ps1
  exit 1
)

set QMSKYCULDIR=%STELDIR%\translations\stellarium-skycultures
if not exist "%QMSKYCULDIR%" (
  powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\not_installed_msg.ps1
  exit 1
)

set SSCDIR=%STELDIR%\scripts
if not exist "%SSCDIR%" (
  powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\not_installed_msg.ps1
  exit 1
)

set DESTDIR=%SSCDIR%\interstellar-console

echo DESTDIR:
echo %DESTDIR%

if "%PD%" == "%DESTDIR%" (
  echo ERROR: SRC directory is DEST directory!
  powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\unknown_err_msg.ps1
  exit 1
)

if exist "%DESTDIR%" (
  dir "%DESTDIR%\." >nul 2>&1
  if errorlevel 1 (
    echo ERROR: %DESTDIR% already exists, but it is a file!
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\unknown_err_msg.ps1
    exit 1
  ) else (
    echo OK: %DESTDIR%
  )
) else (
  mkdir "%DESTDIR%"
  if exist "%DESTDIR%" (
    echo OK: %DESTDIR%
  ) else (
    echo ERROR: cannot create %DESTDIR%
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\unknown_err_msg.ps1
    exit 1
  )
)


echo ݒ蒆...

cacls "%DESTDIR%" /E /G Users:F
timeout /t 3 /nobreak >nul


echo t@CRs[...

xcopy ".\isc_*.exe" "%DESTDIR%\." /F /Y /R
xcopy ".\nircmd-x64\nircmd.exe" "%DESTDIR%\." /F /Y /R
xcopy ".\nkfwin\nkf.exe" "%DESTDIR%\." /F /Y /R
xcopy ".\*.bat" "%DESTDIR%\." /F /Y /R
xcopy ".\*.ps1" "%DESTDIR%\." /F /Y /R
xcopy ".\*.tcl" "%DESTDIR%\." /F /Y /R
xcopy ".\splash.gif" "%DESTDIR%\." /F /Y /R
xcopy ".\*.inc" "%DESTDIR%\." /F /Y /R
xcopy ".\*.ssc" "%DESTDIR%\." /F /Y /R
xcopy ".\*.txt" "%DESTDIR%\." /F /Y /R
xcopy ".\images\*" "%DESTDIR%\images\." /F /Y /R /I /E
xcopy ".\milkyway\*" "%DESTDIR%\milkyway\." /F /Y /R /I /E
xcopy ".\japanese\*" "%SKYCULDIR%\japanese\." /F /Y /R /I /E
if exist "%QMSKYCULDIR%\ja.qm" (
  if not exist "%QMSKYCULDIR%\ja.qm.old" (
    copy "%QMSKYCULDIR%\ja.qm" "%QMSKYCULDIR%\ja.qm.old" /B /Y
  )
)
xcopy ".\translations\ja.qm" "%QMSKYCULDIR%\." /F /Y /R


echo Tcl/Tk-8p\[Xt@C쐬...

if not exist "%DESTDIR%\tcl_sjis" (
  mkdir "%DESTDIR%\tcl_sjis"
)
.\nkfwin\nkf.exe -W -s .\misato-gui.tcl > "%DESTDIR%\tcl_sjis\misato-gui.tcl"
.\nkfwin\nkf.exe -W -s .\date-gui.tcl > "%DESTDIR%\tcl_sjis\date-gui.tcl"
.\nkfwin\nkf.exe -W -s .\date-monitor.tcl > "%DESTDIR%\tcl_sjis\date-monitor.tcl"


echo fXNgbvɃV[gJbg쐬...

if not exist "%HOMEDRIVE%%HOMEPATH%\Desktop" (
  goto next0
)

  set EXENAME=isc_navigator
  if not exist "%HOMEDRIVE%%HOMEPATH%\Desktop\%EXENAME%.lnk" (
    echo 쐬 : %EXENAME%
    REM cscript /nologo setup\mk_shortcut.vbs "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\mk_shortcut.ps1 "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
  ) else (
    echo łɑ : %EXENAME%
  )
  set EXENAME=isc_dome
  if not exist "%HOMEDRIVE%%HOMEPATH%\Desktop\%EXENAME%.lnk" (
    echo 쐬 : %EXENAME%
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\mk_shortcut.ps1 "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
  ) else (
    echo łɑ : %EXENAME%
  )
  set EXENAME=isc_gui
  if not exist "%HOMEDRIVE%%HOMEPATH%\Desktop\%EXENAME%.lnk" (
    echo 쐬 : %EXENAME%
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\mk_shortcut.ps1 "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
  ) else (
    echo łɑ : %EXENAME%
  )

:next0

if not exist "%HOMEDRIVE%%HOMEPATH%\OneDrive\Desktop" (
  goto next1
)

  set EXENAME=isc_navigator
  if not exist "%HOMEDRIVE%%HOMEPATH%\OneDrive\Desktop\%EXENAME%.lnk" (
    echo 쐬 : %EXENAME%
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\mk_shortcut.ps1 "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
  ) else (
    echo łɑ : %EXENAME%
  )
  set EXENAME=isc_dome
  if not exist "%HOMEDRIVE%%HOMEPATH%\OneDrive\Desktop\%EXENAME%.lnk" (
    echo 쐬 : %EXENAME%
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\mk_shortcut.ps1 "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
  ) else (
    echo łɑ : %EXENAME%
  )
  set EXENAME=isc_gui
  if not exist "%HOMEDRIVE%%HOMEPATH%\OneDrive\Desktop\%EXENAME%.lnk" (
    echo 쐬 : %EXENAME%
    powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\mk_shortcut.ps1 "%DESTDIR%\%EXENAME%.exe" "%USERPROFILE%\Desktop\%EXENAME%.lnk" "%DESTDIR%"
  ) else (
    echo łɑ : %EXENAME%
  )

:next1


echo ZbgAbv܂I

powershell.exe -NoLogo -ExecutionPolicy %EXPOLICY% -File .\setup\last_msg.ps1

